<template>
  <ValidationObserver
    v-slot="{ valid }"
    ref="observer"
    tag="form"
    @submit.prevent="submit()"
  >
    <b-container fluid class="login-wrapper">
      <b-row class="justify-content-md-center login-form">
        <b-col lg="4">
          <div class="login-form--content">
            <div class="login-form--header">
              <h1>Login</h1>
            </div>
            
            <div class="login-form--body">
              <b-input-group class="mb-2">
                <ValidationProvider
                  v-slot="{ errors, touched }"
                  :rules="'required'"
                  name="userName"
                  >
                    <b-form-input
                      type="text"
                      placeholder="Nome do usuário"
                      name="userName"
                      v-model="username"
                      :state="touched ? valid : null"
                      >
                    </b-form-input>

                    <span class="error">
                      {{ errors[0] }}
                    </span>
                </ValidationProvider> 
              </b-input-group>

              <b-input-group class="mb-2">
                <ValidationProvider
                  v-slot="{ errors, touched }"
                  :rules="'required'"
                  name="password"
                  >
                    <b-form-input
                      type="text"
                      placeholder="Senha"
                      name="password"
                      :state="touched ? valid : null"
                      v-model="password">
                    </b-form-input>
                    <span class="error">
                      {{ errors[0] }}
                    </span>
                </ValidationProvider> 
              </b-input-group>
            </div>

            <div class="login-form--footer">
              <div class="row">
                <div class="col-md-12">
                  <b-button
                    :disabled="!valid"
                    variant="primary"
                    @click="submit">
                      Acessar
                  </b-button>
                </div>
              </div>
            </div>
          </div>
        </b-col>
      </b-row>
    </b-container>
  </ValidationObserver>  
</template>

<script>
import { mapActions } from 'vuex'

export default {
  name: 'login',

  data() {
    return {
      username: null,
      password: null
    }
  },

  methods: {
    ...mapActions([
      'getToken'
    ]),

    async submit() {
      const isValid = await this.$refs.observer.validate()
      if (isValid) {
        const credentials = { 
          username: this.username,
          password: this.password
        }
        this.getToken(credentials).then(response => {
          this.$router.push({ name: 'addQuery' })
        })
      }
    }
  }
}
</script>

<style lang="scss">
.login-wrapper {
  background-color: #455264;
  height: 100vh;

  .login-form {
    align-items: center;
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    justify-content: center;
    height: 100%;

    .login-form--content {
      background-color: #ffffff;
      box-shadow: 0 0 9px 0 rgba(0, 0, 0, 0.3);
      width: 100%;

      .login-form--header {
        h1 {
          text-align: center;
          color: #5b6574;
          font-size: 24px;
          padding: 20px 0;
          border-bottom: 1px solid #dee0e4;
          font-weight: bold;
        }
      }

      .login-form--body {
        padding: 30px;
      }

      .login-form--footer {
        button {
          width: 100%;
          border-radius: 0;
          height: 50px;
          font-weight: bold;
          text-transform: uppercase;
        }
      }
    }
  }  
}
</style>